Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcini_c14b.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcini_c14b.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcini_c14b.F90	(revision 2643)
@@ -17,5 +17,4 @@
    USE trc             ! TOP variables
    USE trcsms_c14b     ! C14 sms trends
-   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
@@ -59,6 +58,7 @@
       !!----------------------------------------------------------------------
 
-      !  Control consitency
-      CALL trc_ctl_c14b
+      CALL c14b_alloc()       ! Allocate CFC arrays
+
+      CALL trc_ctl_c14b     !  Control consitency
 
       IF(lwp) WRITE(numout,*) ''
@@ -164,4 +164,17 @@
 
    END SUBROUTINE trc_ini_c14b
+
+   SUBROUTINE c14b_alloc
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE c14b_alloc  ***
+      !!
+      !! ** Purpose :   Allocate all the dynamic arrays of C14b
+      !!----------------------------------------------------------------------
+
+      !                                ! Allocate C14b arrays
+      IF( trc_sms_c14b_alloc() /= 0 )   &
+         &         CALL ctl_stop( 'STOP', 'trc_ini_c14b : unable to allocate C14b arrays' )
+      !
+   END SUBROUTINE c14b_alloc
    
    SUBROUTINE trc_ctl_c14b
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 2643)
@@ -16,5 +16,4 @@
    USE trc             ! TOP variables
    USE trcsms_c14b     ! C14b specific variable
-   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90	(revision 2643)
@@ -17,5 +17,4 @@
    USE trc             ! TOP variables
    USE trcsms_c14b          ! c14b sms trends
-   USE in_out_manager  ! I/O manager
    USE iom
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2643)
@@ -63,19 +63,4 @@
 CONTAINS
 
-  FUNCTION trc_sms_c14b_alloc()
-     !!----------------------------------------------------------------------
-     !!                  ***  ROUTINE trc_sms_c14b_alloc  ***
-     !!----------------------------------------------------------------------
-     INTEGER :: trc_sms_c14b_alloc  ! Return value
-     !!----------------------------------------------------------------------
-
-     ALLOCATE(fareaz(jpi,jpj ,jpzon), &
-              qtr_c14(jpi,jpj)      , &
-              qint_c14(jpi,jpj)     , Stat=trc_sms_c14b_alloc)
-
-     IF (trc_sms_c14b_alloc /= 0) CALL ctl_warn('trc_sms_c14b_alloc : failed to allocate arrays.')
-
-  END FUNCTION trc_sms_c14b_alloc
-
 
   SUBROUTINE trc_sms_c14b( kt )
@@ -121,30 +106,23 @@
 
      !! * Local declarations
-     INTEGER ::  &
-       ji, jj, jk, jz
-
-     INTEGER ::   &
-       iyear_beg,              &
-       iyear_beg1, iyear_end1, &
-       imonth1, im1, im2,      &
-       iyear_beg2, iyear_end2, &
-       imonth2, in1, in2
+     INTEGER :: ji, jj, jk, jz     ! dummy loop indices 
+
+     INTEGER :: iyear_beg, iyear_beg1, iyear_end1 
+     INTEGER :: iyear_beg2, iyear_end2 
+     INTEGER :: imonth1, im1, in1 
+     INTEGER :: imonth2, im2, in2 
          
-     REAL(wp), DIMENSION(jpzon)   ::  &
-       zonbc14              !: time interp atm C14
-
-     REAL(wp) ::     &
-       zpco2at              !: time interp atm C02
-
-     REAL(wp) ::     &      !: dummy variables
-       zt, ztp, zsk, &
-       zsol ,        &      !: solubility
-       zsch ,        &      !: schmidt number
-       zv2  ,        &      !: wind speed ( square)
-       zpv  ,        &      !: piston velocity 
-       zdemi, ztra
+     REAL(wp), DIMENSION(jpzon) :: zonbc14       !: time interp atm C14 
+     REAL(wp)                   :: zpco2at       !: time interp atm C02 
+
+     REAL(wp) :: zt, ztp, zsk      !: dummy variables
+     REAL(wp) :: zsol              !: solubility
+     REAL(wp) :: zsch              !: schmidt number
+     REAL(wp) :: zv2               !: wind speed ( square)
+     REAL(wp) :: zpv               !: piston velocity 
+     REAL(wp) :: zdemi, ztra
       !!----------------------------------------------------------------------
 
-      IF( wrk_in_use(2, 1) .OR. wrk_in_use(3, 1) )THEN
+      IF( ( wrk_in_use(2, 1) ) .OR. ( wrk_in_use(3, 1) ) ) THEN
          CALL ctl_stop('trc_sms_c14b : requested workspace arrays unavailable.')
          RETURN
@@ -331,10 +309,21 @@
       END IF
 
-      IF( wrk_not_released(2, 1) .OR. wrk_not_released(3, 1) )THEN
-         CALL ctl_stop('trc_sms_c14b : failed to release workspace arrays.')
-      END IF
+      IF( ( wrk_not_released(2, 1)) .OR. ( wrk_not_released(3, 1) ) )   &
+      &   CALL ctl_stop('trc_sms_c14b : failed to release workspace arrays.')
 
     END SUBROUTINE trc_sms_c14b
 
+  INTEGER FUNCTION trc_sms_c14b_alloc()
+     !!----------------------------------------------------------------------
+     !!                  ***  ROUTINE trc_sms_c14b_alloc  ***
+     !!----------------------------------------------------------------------
+
+     ALLOCATE( fareaz(jpi,jpj ,jpzon),     &
+       &       qtr_c14(jpi,jpj)      ,     &
+       &       qint_c14(jpi,jpj)     , STAT=trc_sms_c14b_alloc )
+
+     IF( trc_sms_c14b_alloc /= 0 ) CALL ctl_warn('trc_sms_c14b_alloc : failed to allocate arrays.')
+
+  END FUNCTION trc_sms_c14b_alloc
 #else
     !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 2643)
@@ -15,6 +15,5 @@
    USE par_trc         ! TOP parameters
    USE trc             ! TOP variables
-   USE trcsms_cfc          ! CFC sms trends
-   USE in_out_manager  ! I/O manager
+   USE trcsms_cfc      ! CFC sms trends
 
    IMPLICIT NONE
@@ -45,6 +44,6 @@
       !! ** Method  : - Read the namcfc namelist and check the parameter values
       !!----------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jn, jl, jm, js
-      REAL(wp) ::   zyy  ,  zyd
+      INTEGER  ::  ji, jj, jn, jl, jm, js
+      REAL(wp) ::  zyy  ,  zyd
       !!----------------------------------------------------------------------
 
@@ -52,4 +51,6 @@
       IF(lwp) WRITE(numout,*) ' trc_ini_cfc: initialisation of CFC chemical model'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
+
+      CALL cfc_alloc()       ! Allocate CFC arrays
 
 
@@ -140,4 +141,17 @@
 
    END SUBROUTINE trc_ini_cfc
+
+   SUBROUTINE cfc_alloc
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE cfc_alloc  ***
+      !!
+      !! ** Purpose :   Allocate all the dynamic arrays of CFC
+      !!----------------------------------------------------------------------
+
+      !                                ! Allocate CFC arrays
+      IF( trc_sms_cfc_alloc() /= 0 )   &
+         &           CALL ctl_stop( 'STOP', 'trc_ini_cfc : unable to allocate CFC arrays' )
+      !
+   END SUBROUTINE cfc_alloc
    
 #else
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 2643)
@@ -16,5 +16,4 @@
    USE trc             ! TOP variables
    USE trcsms_cfc      ! CFC specific variable
-   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcrst_cfc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcrst_cfc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcrst_cfc.F90	(revision 2643)
@@ -17,5 +17,4 @@
    USE trc             ! TOP variables
    USE trcsms_cfc          ! CFC sms trends
-   USE in_out_manager  ! I/O manager
    USE iom
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2643)
@@ -60,22 +60,4 @@
 CONTAINS
 
-   FUNCTION trc_sms_cfc_alloc()
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_sms_cfc_alloc  ***
-      !!----------------------------------------------------------------------
-      INTEGER :: trc_sms_cfc_alloc
-      !!----------------------------------------------------------------------
-
-      ALLOCATE(xphem(jpi,jpj),           &
-               qtr_cfc(jpi,jpj,jp_cfc),  &
-               qint_cfc(jpi,jpj,jp_cfc), &
-               Stat=trc_sms_cfc_alloc)
-
-      IF(trc_sms_cfc_alloc /= 0)THEN
-         CALL ctl_warn('trc_sms_cfc_alloc : failed to allocate arrays.')
-      END IF
-
-   END FUNCTION trc_sms_cfc_alloc
-
 
    SUBROUTINE trc_sms_cfc( kt )
@@ -115,5 +97,5 @@
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(3, 1))THEN
+      IF( wrk_in_use(3, 1) ) THEN
          CALL ctl_stop('trc_sms_cfc : requested workspace array unavailable.')
          RETURN
@@ -202,10 +184,10 @@
 #if defined key_diatrc 
       ! Save diagnostics , just for CFC11
-# if ! defined key_iomput
+# if  defined key_iomput
+      CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
+      CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
+# else
       trc2d(:,:,jp_cfc0_2d    ) = qtr_cfc (:,:,1)
       trc2d(:,:,jp_cfc0_2d + 1) = qint_cfc(:,:,1)
-# else
-      CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
-      CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
 # endif
 #endif
@@ -218,7 +200,5 @@
       END IF
 
-      IF(wrk_not_released(3, 1))THEN
-         CALL ctl_stop('trc_sms_cfc : failed to release workspace array.')
-      END IF
+      IF( wrk_not_released(3, 1) ) CALL ctl_stop('trc_sms_cfc : failed to release workspace array.')
 
    END SUBROUTINE trc_sms_cfc
@@ -272,4 +252,18 @@
    END SUBROUTINE trc_cfc_cst
    
+   INTEGER FUNCTION trc_sms_cfc_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_sms_cfc_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( xphem(jpi,jpj)          ,    &
+         &      qtr_cfc(jpi,jpj,jp_cfc) ,    &
+         &      qint_cfc(jpi,jpj,jp_cfc),    &
+         &                               STAT=trc_sms_cfc_alloc )
+
+      IF( trc_sms_cfc_alloc /= 0 ) CALL ctl_warn('trc_sms_cfc_alloc : failed to allocate arrays.')
+
+   END FUNCTION trc_sms_cfc_alloc
+
 #else
    !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90	(revision 2643)
@@ -112,15 +112,25 @@
       !!        *** ROUTINE sms_lobster_alloc ***
       !!----------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
+      USE lib_mpp, ONLY:   ctl_warn   ! MPP library
+      INTEGER :: ierr(3)        ! Local variables
       !!----------------------------------------------------------------------
-      !
-      ALLOCATE( remdmp(jpk,jp_lobster),                                   &
-         &      neln(jpi,jpj),    xze(jpi,jpj),     xpar(jpi,jpj,jpk),    &
-         &      dminl(jpi,jpj),   dmin3(jpi,jpj,jpk),                     &
-         &      sedpocb(jpi,jpj), sedpocn(jpi,jpj), sedpoca(jpi,jpj),     &
-         &      fbod(jpi,jpj),    cmask(jpi,jpj)                    , STAT=sms_lobster_alloc )
-         !
-      IF( sms_lobster_alloc /= 0 )   CALL ctl_warn('sms_lobster_alloc : failed to allocate arrays')
-      !
+
+      ierr(:) = 0
+      !*  Biological parameters
+      ALLOCATE( remdmp(jpk,jp_lobster),                               STAT=ierr(1) )
+
+      !*  Optical parameters
+      ALLOCATE( neln(jpi,jpj)     , xze(jpi,jpj),                         &
+        &       xpar(jpi,jpj,jpk) ,                                   STAT=ierr(2) )
+
+      !*  Sediment parameters
+      ALLOCATE( dminl(jpi,jpj)  , dmin3(jpi,jpj,jpk),                     &
+        &       sedpocb(jpi,jpj), sedpocn(jpi,jpj)  , sedpoca(jpi,jpj),   &
+        &       fbod(jpi,jpj)   , cmask(jpi,jpj)    ,                 STAT=ierr(3) ) 
+
+      sms_lobster_alloc = MAXVAL( ierr )
+  
+      IF( sms_lobster_alloc /= 0 ) CALL ctl_warn('sms_lobster_alloc : failed to allocate arrays.')
+
    END FUNCTION sms_lobster_alloc
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcbio.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 2643)
@@ -86,5 +86,5 @@
 
 #if defined key_diatrc && defined key_iomput
-      IF( wrk_in_use(3, 2) .OR. wrk_in_use(4, 1) )THEN
+      IF( ( wrk_in_use(3, 2) ) .OR. ( wrk_in_use(4, 1) ) ) THEN
          CALL ctl_stop('trc_bio : requested workspace arrays unavailable.')
          RETURN
@@ -103,11 +103,12 @@
       fbod(:,:) = 0.e0
 #if defined key_diatrc && ! defined key_iomput
+#  if defined key_iomput
+      zw2d  (:,:,:) = 0.e0
+      zw3d(:,:,:,:) = 0.e0
+#  else
       DO jl = jp_lob0_2d, jp_lob1_2d
          trc2d(:,:,jl) = 0.e0
       END DO 
-#endif
-#if defined key_diatrc && defined key_iomput
-      zw2d(:,:,:) = 0.e0
-      zw3d(:,:,:,:) = 0.e0
+#  endif
 #endif
 
@@ -500,7 +501,6 @@
       !
 #if defined key_diatrc && defined key_iomput
-      IF( wrk_not_released(3, 2) .OR. wrk_not_released(4, 1) )THEN
-         CALL ctl_stop('trc_bio : failed to release workspace arrays.')
-      END IF
+      IF( ( wrk_not_released(3, 2) ) .OR. ( wrk_not_released(4, 1) ) )  &
+        &   CALL ctl_stop('trc_bio : failed to release workspace arrays.')
 #endif
       !
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2643)
@@ -101,5 +101,5 @@
             sedpoca(ji,jj) = ( zwork + dminl(ji,jj) * fbod(ji,jj)   &
                &           - sedlam * sedpocn(ji,jj) - sedlostpoc * sedpocn(ji,jj) ) * rdt
-            zgeolpoc = zgeolpoc + sedlostpoc * sedpocn(ji,jj) * e1t(ji,jj) * e2t(ji,jj)
+            zgeolpoc = zgeolpoc + sedlostpoc * sedpocn(ji,jj) * e1e2t(ji,jj)
          END DO
       END DO
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcini_lobster.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcini_lobster.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcini_lobster.F90	(revision 2643)
@@ -21,6 +21,4 @@
    USE trc
    USE lbclnk 
-   USE lib_mpp 
-   USE lib_fortran 
 
    IMPLICIT NONE
@@ -50,16 +48,15 @@
       !!----------------------------------------------------------------------
 
-      IF( wrk_in_use(2, 1) .OR. wrk_in_use(3, 1) )THEN
-         CALL ctl_stop('trc_ini_lobster : requested workspace arrays unavailable.')
-         RETURN
-      END IF
-
-      !  Control consitency
-      CALL trc_ctl_lobster
-
-
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) ' trc_ini_lobster :   LOBSTER biochemical model initialisation'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~~'
+
+
+      CALL lobster_alloc()       ! Allocate LOBSTER arrays
+
+      IF( ( wrk_in_use(2, 1) ) .OR. ( wrk_in_use(3, 1) ) )  THEN
+         CALL ctl_stop('trc_ini_lobster : requested workspace arrays unavailable.')   ;  RETURN
+      ENDIF
+
 
       ! initialization of fields for optical model
@@ -144,5 +141,5 @@
       ! Coastal surface
       ! ---------------
-      areacot = glob_sum( e1t(:,:) * e2t(:,:) * cmask(:,:) )
+      areacot = glob_sum( e1e2t(:,:) * cmask(:,:) )
 
       ! Initialization of tracer concentration in case of  no restart 
@@ -226,5 +223,6 @@
          trn(:,:,30,jp_lob_no3) = 20.01 * tmask(:,:,30)
 
-# elif defined key_gyre
+
+# elif defined key_gyre || defined key_orca_r2
          ! LOBSTER initialisation for GYRE
          ! ----------------------
@@ -259,71 +257,21 @@
       IF(lwp) WRITE(numout,*) ' '
 
-      IF( wrk_not_released(2, 1) .OR. wrk_not_released(3, 1) )THEN
-         CALL ctl_stop('trc_ini_lobster : failed to release workspace arrays.')
-      END IF
+      IF( ( wrk_not_released(2, 1) ) .OR. ( wrk_not_released(3, 1) ) )   &
+        &      CALL ctl_stop('trc_ini_lobster : failed to release workspace arrays.')
 
    END SUBROUTINE trc_ini_lobster
 
-   SUBROUTINE trc_ctl_lobster
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ctl_lobster  ***
+   SUBROUTINE lobster_alloc
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE lobster_alloc  ***
       !!
-      !! ** Purpose :   control the cpp options, namelist and files 
-      !!----------------------------------------------------------------------
-      INTEGER :: jl, jn
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' use LOBSTER biological model '
-
-      ! Check number of tracers
-      ! -----------------------
-      IF( jp_lobster /= 6 ) CALL ctl_stop( ' LOBSTER has 6 passive tracers. Change jp_lobster in par_lobster.F90' )
-
-      ! Check tracer names
-      ! ------------------
-      IF(   ctrcnm(jp_lob_det) /= 'DET' .OR. ctrcnm(jp_lob_zoo) /= 'ZOO' .OR.   &
-         &  ctrcnm(jp_lob_phy) /= 'PHY' .OR. ctrcnm(jp_lob_no3) /= 'NO3' .OR.   &
-         &  ctrcnm(jp_lob_nh4) /= 'NH4' .OR. ctrcnm(jp_lob_dom) /= 'DOM' .OR.   &
-         &  ctrcnl(jp_lob_det) /= 'Detritus'                        .OR.   &
-         &  ctrcnl(jp_lob_zoo) /= 'Zooplankton concentration'       .OR.   &
-         &  ctrcnl(jp_lob_phy) /= 'Phytoplankton concentration'     .OR.   &
-         &  ctrcnl(jp_lob_no3) /= 'Nitrate concentration'           .OR.   &
-         &  ctrcnl(jp_lob_nh4) /= 'Ammonium concentration'          .OR.   &
-         &  ctrcnl(jp_lob_dom) /= 'Dissolved organic matter' ) THEN
-         ctrcnm(jp_lob_det)='DET'
-         ctrcnl(jp_lob_det)='Detritus'
-         ctrcnm(jp_lob_zoo)='ZOO'
-         ctrcnl(jp_lob_zoo)='Zooplankton concentration'
-         ctrcnm(jp_lob_phy)='PHY'
-         ctrcnl(jp_lob_phy)='Phytoplankton concentration'
-         ctrcnm(jp_lob_no3)='NO3'
-         ctrcnl(jp_lob_no3)='Nitrate concentration'
-         ctrcnm(jp_lob_nh4)='NH4'
-         ctrcnl(jp_lob_nh4)='Ammonium concentration'
-         ctrcnm(jp_lob_dom)='DOM'
-         ctrcnl(jp_lob_dom)='Dissolved organic matter'
-         IF(lwp) THEN
-            CALL ctl_warn( ' We force tracer names ' )
-            DO jl = 1, jp_lobster
-               jn = jp_lob0 + jl - 1
-               WRITE(numout,*) ' tracer nb: ',jn,' name = ',ctrcnm(jn), ctrcnl(jn)
-            END DO
-            WRITE(numout,*) ' '
-         ENDIF
-      ENDIF
-
-      ! Check tracer units
-      DO jl = 1, jp_lobster
-         jn = jp_lob0 + jl - 1
-         IF( ctrcun(jn) /= 'mmole-N/m3') THEN
-            ctrcun(jn) = 'mmole-N/m3'
-            IF(lwp) THEN
-               CALL ctl_warn( ' We force tracer units ' )
-               WRITE(numout,*) ' tracer  ',ctrcnm(jn), 'UNIT= ',ctrcun(jn)
-            ENDIF
-         ENDIF
-      END DO
-
-   END SUBROUTINE trc_ctl_lobster
+      !! ** Purpose :   Allocate all the dynamic arrays of LOBSTER
+      !!----------------------------------------------------------------------
+
+      !                                ! Allocate LOBSTER arrays
+      IF( sms_lobster_alloc() /= 0 )   &
+      &              CALL ctl_stop( 'STOP', 'trc_ini_lobster : unable to allocate LOBSTER arrays' )
+      !
+   END SUBROUTINE lobster_alloc
 
 #else
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2643)
@@ -16,6 +16,4 @@
    USE trc              ! TOP variables
    USE sms_lobster      ! sms trends
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2643)
@@ -21,5 +21,4 @@
    USE sms_lobster
    USE prtctl_trc      ! Print control for debbuging
-   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
@@ -69,5 +68,5 @@
       !!---------------------------------------------------------------------
 
-      IF( (wrk_in_use(2, 1,2)) .OR. (wrk_in_use(3, 2,3)) )THEN
+      IF( ( wrk_in_use(2, 1,2)) .OR. ( wrk_in_use(3, 2,3)) )THEN
          CALL ctl_stop('trc_opt : requested workspace arrays unavailable')   ;   RETURN
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcrst_lobster.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcrst_lobster.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcrst_lobster.F90	(revision 2643)
@@ -18,5 +18,4 @@
    USE trcsms_lobster          ! lobster sms trends
    USE sms_lobster          ! lobster sms trends
-   USE in_out_manager  ! I/O manager
    USE iom
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2643)
@@ -69,5 +69,5 @@
       !!---------------------------------------------------------------------
 
-      IF( (wrk_in_use(3,2)) .OR. (wrk_in_use(2,1)) )THEN
+      IF( ( wrk_in_use(3,2)) .OR. ( wrk_in_use(2,1)) ) THEN
          CALL ctl_stop('trc_sed : requested workspace arrays unavailable.')
          RETURN
@@ -150,7 +150,6 @@
       ENDIF
 
-      IF( (wrk_not_released(3,2)) .OR. (wrk_not_released(2,1)) )THEN
-         CALL ctl_stop('trc_sed : failed to release workspace arrays.')
-      END IF
+      IF( ( wrk_not_released(3, 2) ) .OR. ( wrk_not_released(2, 1) ) )  &
+       &         CALL ctl_stop('trc_sed : failed to release workspace arrays.')
 
    END SUBROUTINE trc_sed
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2643)
@@ -23,5 +23,4 @@
    USE trdmod_trc
    USE trdmld_trc
-   USE lib_mpp          ! MPP library
 
    IMPLICIT NONE
@@ -53,5 +52,5 @@
       !! --------------------------------------------------------------------
 
-      IF( wrk_in_use(3,1) ) THEN
+      IF( wrk_in_use(3, 1) ) THEN
          CALL ctl_stop('trc_sms_lobster : requested workspace array unavailable')   ;   RETURN
       ENDIF
@@ -71,5 +70,5 @@
       IF( lk_trdmld_trc )  CALL trd_mld_bio( kt )   ! trends: Mixed-layer
 
-      IF( wrk_not_released(3,1) )   CALL ctl_stop('trc_sms_lobster : failed to release workspace array.')
+      IF( wrk_not_released(3, 1) )   CALL ctl_stop('trc_sms_lobster : failed to release workspace array.')
       !
    END SUBROUTINE trc_sms_lobster
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 2643)
@@ -38,6 +38,7 @@
       !!----------------------------------------------------------------------
 
-      !  Control consitency
-      CALL trc_ctl_my_trc
+      CALL my_trc_alloc()     ! Allocate MY_TRC arrays
+
+      CALL trc_ctl_my_trc     ! Control consitency
 
       IF(lwp) WRITE(numout,*)
@@ -64,5 +65,5 @@
       DO jl = 1, jp_my_trc
          jn = jp_myt0 + jl - 1
-         WRITE(ctrcnm(jn),'(a,i2.2)') 'CLR',jn
+         WRITE( ctrcnm(jn),'(a,i2.2)' ) 'CLR', jn
          ctrcnl(jn)='Color concentration'
          ctrcun(jn)='N/A'
@@ -71,4 +72,15 @@
 
    END SUBROUTINE trc_ctl_my_trc
+
+   SUBROUTINE my_trc_alloc
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE my_trc_alloc  ***
+      !!
+      !! ** Purpose :   Allocate all the dynamic arrays of MY_TRC
+      !!----------------------------------------------------------------------
+
+      !                                ! Allocate MY_TRC arrays
+      !
+   END SUBROUTINE my_trc_alloc
 
 #else
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2643)
@@ -32,9 +32,4 @@
 
    PUBLIC  p4z_bio    
-
-   !! * Shared module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &  !:
-      xnegtr            ! Array used to indicate negative tracer values
-
 
    !!* Substitution
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2643)
@@ -25,11 +25,10 @@
 
    PUBLIC   p4z_che  
+   PUBLIC   p4z_che_alloc  
 
    !! * Shared module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      sio3eq, fekeq           !: chemistry of Fe and Si
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,2)   ::   &   !:
-      chemc                   !: Solubilities of O2 and CO2
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sio3eq  ! chemistry of Si
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: fekeq   ! chemistry of Fe
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: chemc   ! Solubilities of O2 and CO2
 
    !! * Module variables
@@ -156,4 +155,5 @@
 CONTAINS
 
+
    SUBROUTINE p4z_che
       !!---------------------------------------------------------------------
@@ -324,4 +324,15 @@
    END SUBROUTINE p4z_che
 
+   INTEGER FUNCTION p4z_che_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_che_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( sio3eq(jpi,jpj,jpk), fekeq(jpi,jpj,jpk),  &
+        &       chemc(jpi,jpj,2),                     STAT=p4z_che_alloc )
+
+      IF( p4z_che_alloc /= 0 ) CALL ctl_warn('p4z_che_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_che_alloc
 #else
    !!======================================================================
